//*****************************************************
//Project : Sonda 
//Version : Version 1.0a - Sonda TEST
//Date    : 16.8.2007
//Author  : Jan TOMLAIN
//Company : T-Industry, s.r.o.
//Comments: Operating Program for Sonda

//Chip type           : ATmega13
//Program type        : Application
//Clock frequency     : 0,600000 MHz
//****************************************************/
//      Main Hiders and Includes
/*****************************************************/
#define F_XTAL 4800000L          // 0.6MHZ definition
#define DAT    0x04	        // PB.2 - DAT to 74164
#define CLK    0x02	        // PB.1 - CLK to 74164

#define LOW 36                  // 0,7 V --> 36deca
#define NEDEFINED 112            // 2,2 V --> 112deca 

#include <tiny13.h>
#include <delay.h>
//***********************************************************
char cisla[10] = {0b10001000,0b10111110,0b11000100,0b10010100,
                  0b10110010,0b10010001,0b10000001,0b10111100,
                  0b10000000,0b10010000}; // 0,1,2,3,4,5,6,7,8,9
char stavy[5] = {0b11100000,0b11001011,0b10100010,0b10000111,0b11110111}; // P, L, H, o, -
//***********************************************************
// Declare your global variables here
//***********************************************************
unsigned int i;
char ADCHm,ADCLm;
//***********************************************************
//*      Main Cycle
//*********************************************************
void SH164 (unsigned char tt) { int i; unsigned char cha; cha = tt;
     for (i=0; i<8; i++) { if ((cha & 0x80) == 0x80) { PORTB |= DAT; }
         else {PORTB &= ~DAT;}
     PORTB &= ~CLK; PORTB |= CLK; cha = cha << 1; } }                      
//*********************************************************
interrupt [PCINT0] void pcie0(void)
{
SH164(stavy[0]);
delay_ms(400); 
}       
//*********************************************************
void main(void){
//***********************************************************
//*     Sonda
//***********************************************************
        PORTB = DAT+CLK;        // define io pins - output
        DDRB  = DAT+CLK;
//***********************************************************
//      Interrupts and ADC config
//***********************************************************
       ADMUX=0b00100011;       // ADALR,Reference VCC, input PB3
       ADCSRA=0b11100000;      // ADC enable, FREE Running mode, division 2            
//***********************************************************
       PCMSK=0b00010000;       // PCINT4
       GIMSK=0b00100000;       // PCIE enable
//***********************************************************
          #asm("sei")                  // I-flag set on
      SH164(stavy[4]);

loop: 
        ADCLm=ADCL;
        ADCHm=ADCH;
//        ADCHm = 120;  

        if(ADCHm<LOW){       SH164(stavy[1]); goto ll;  } 
        if(ADCHm<=NEDEFINED){ SH164(stavy[3]); goto ll; }
        if(ADCHm>NEDEFINED){  SH164(stavy[2]); goto ll; }
//***********************************************************
ll:     delay_ms(100);
     goto    loop;             

//***********************************************************
}



__________ Informacia od ESET NOD32 Antivirus, verzia databazy 4505 (20091014) __________

Tuto spravu preveril ESET NOD32 Antivirus.

http://www.eset.sk

